var reg;
var textgross = false;
var eingeschaltet = [];
var copiedRegistration = "";
var exportGrafikBreite = 100;

// Get the root element and css variables
var r = document.querySelector(':root');
var rs = getComputedStyle(r);

function scale(reg,id){
	id2 = id.split("t");
	id = id2[1];
	var alterText = reg.innerHTML;
	if (textgross==true){
		resetRegName();
		reg.classList.remove("textBig");
		textgross = false;
	}
	else {
		reg.innerHTML = "<tspan fill='var(--textbignrfill)' stroke='var(--textbignrstroke'>" + id + "•</tspan>" + alterText;
		reg.classList.add("textBig");
		textgross = true;
	}
}

function resetRegName(){
	var regname = document.getElementsByClassName("regname");
//console.log(regname);
	var aktuellerText = "";
	for (var i=0; i < regname.length; i++){
			aktuellerText = regname[i].innerHTML;
			var neuerText = aktuellerText.split("•</tspan>");
			if (neuerText[1]!=null){
				regname[i].innerHTML = neuerText[1];
			}
	}
}

function reset(){
	var regname = document.getElementsByClassName("regname");
	var regform = document.getElementsByClassName("regform");
	for (var i=0; i < regname.length; i++){
		var registernummer = i + 1;
		regEinzelnAus(registernummer);
		eingeschaltet[i] = false;
	}
	document.getElementById("info").innerHTML = "";
	var s = document.getElementById("registerAuswahl");
	s.focus();
}

function regEin(register){
//	console.log(register);
	if (register==""){reset(); return}
	if (register=="reset"){reset(); return}

	reset();
	reg=register;
	for (var i=0; i<reg.length-1; i++){
		regEinzelnEin(reg[i]);
		eingeschaltet[reg[i] - 1] = true;
	}
	document.getElementById("info").textContent = reg[i];
}

function regEinzelnEin(register){
//console.log("ON:" + register);
	if (register==""){return}
	if (register=="reset"){reset(); return}
	eingeschaltet[register - 1] = true;
	document.getElementById(register.toString()).classList.add("regformOn");
	document.getElementById("t"+register.toString()).classList.add("regnameOn");
}

function regEinzelnAus(register){
//console.log("OFF:" + register);
	if (register==""){return}
	if (register=="reset"){reset(); return}
	eingeschaltet[register - 1] = false;
	document.getElementById(register.toString()).classList.remove("regformOn");
	document.getElementById("t"+register.toString()).classList.remove("regnameOn");
}

function regMultiEin(liste){
	reset();
	for (var i=0; i<liste.length; i++){
		regEinzelnEin(liste[i]);
	}
}

function regMultiAus(liste){
//	reset();
	for (var i=0; i<liste.length; i++){
		regEinzelnAus(liste[i]);
	}
}


function add(){
	var infoElement = document.getElementById("info");
	infoElement.innerHTML = "";
	var regEingeschaltet = "";
	var regname = document.getElementsByClassName("regname");
	var regform = document.getElementsByClassName("regform");
	for (var i=0; i < regname.length; i++){
		if (eingeschaltet[i]== true){
			regEingeschaltet = regEingeschaltet + (i + 1) + ",";
		}
	}
	var ergebnis=regEingeschaltet  //.slice(0,regEingeschaltet.length - 1);
//	alert(ergebnis);
	if (ergebnis==""){
		if (confirm("No current registration available!\nAdd a caption to list?") == true) {
		}
		else {return}
	}

	var element = document.getElementById("registerAuswahl");
	var para = document.createElement("option");
	para.value = ergebnis;

	if (ergebnis==""){
		var registrationsName = prompt("CAPTION:", "***  ***");
	}
	else {
		var registrationsName = prompt("TITLE:", "new");
	}
	para.innerHTML = registrationsName;

	var registrationsInfo = "";
	if (ergebnis!=""){
		registrationsInfo = prompt("INFO: (Beistrich wird ersetzt durch Leerzeichen + ✦!)", "");
	}
	var beistrich = /,/g;
	registrationsInfo = registrationsInfo.replace(beistrich, " ✦");
	para.value = ergebnis + registrationsInfo;
	infoElement.innerHTML = registrationsInfo;

	element.appendChild(para);

	element.selectedIndex = element.options.length - 1;
	element.focus();
}

function change(){
	var s = document.getElementById("registerAuswahl");
	var i = s.selectedIndex;
	var regValue = s.options[i].value;
	var regText = s.options[i].text;

	//Überschrift ändern
	var newRegText = prompt("REGISTRATION TEXT:", regText);
	if (newRegText != null){
		s.options[i].text = newRegText;
	}

	//alte Registrierungsinfo ermitteln
	var pos = regValue.lastIndexOf(",");
	var oldInfo = regValue.slice(pos+1);
	var info = prompt("INFO: (Beistrich wird ersetzt durch Leerzeichen + ✦!)", oldInfo);
	var beistrich = /,/g;
	info = info.replace(beistrich, " ✦");

	//derzeitige Register überprüfen
	var regname = document.getElementsByClassName("regname");
	var regEingeschaltet = "";
	for (var j=0; j < regname.length; j++){
		if (eingeschaltet[j]== true){
			regEingeschaltet = regEingeschaltet + (j + 1) + ",";
		}
	}
	var newRegValue = regEingeschaltet + info //alte Registration ersetzen
	newRegValue = prompt("REGISTER + INFO: ", newRegValue);

	s.options[i].value = newRegValue;
	regEin(newRegValue.split(","));

	var o = document.getElementById("regOptions")
	o.options.selectedIndex = 0;
}


function selectElement(id, valueToSelect) {    
    let element = document.getElementById(id);
    element.value = valueToSelect;
}


// return a promise
function copyToClipboard(textToCopy) {
	if (textToCopy=="" || textToCopy==undefined){
		return;
	}

    // navigator clipboard api needs a secure context (https)
//<![CDATA[
    if (navigator.clipboard && window.isSecureContext) {
        // navigator clipboard api method'
	copiedRegistration = textToCopy;
//	alert(copiedRegistration);
        return navigator.clipboard.writeText(textToCopy);
    } else {
        // text area method
        let textArea = document.createElement("textarea");
        textArea.value = textToCopy;
        // make the textarea out of viewport
        textArea.style.position = "fixed";
        textArea.style.left = "-999999px";
        textArea.style.top = "-999999px";
        document.body.appendChild(textArea);
        textArea.focus();
        textArea.select();
        return new Promise((res, rej) => {
            // here the magic happens
            document.execCommand('copy') ? res() : rej();
	copiedRegistration = textarea[0].value;
//	alert(copiedRegistration);
            textArea.remove();
        });
    }
//]]>
}

//------------------------------------


window.addEventListener('click', function (e) {
//console.log(e.target);
	if (e.target.classList.contains("regform") || e.target.className.baseVal == "regname"){
		var nr = e.target.id;
		if (nr.charAt(0)=="t"){
			const myArray = nr.split("t");
			nr = myArray[1];
		}
		if (eingeschaltet[nr - 1]== true){
			regEinzelnAus(nr);
		}
		else {
			regEinzelnEin(nr);
		}
	}

});




window.addEventListener('contextmenu', function (e) {
//console.log(e.target);
	if (e.target.classList.contains("regform") || e.target.className.baseVal == "regname"){
		e.preventDefault();
		var nr = e.target.id;
		if (nr.charAt(0)!="t"){
			nr = "t" + nr;
		}
		scale(document.getElementById(nr),nr);
	}
	if (e.target.innerHTML == "+"){
		e.preventDefault();
		var pfad = window.location.pathname;
		var dir = pfad.substring(0, pfad.lastIndexOf('/'));
		window.open(dir);
	}

	if (e.target == document.getElementById("registerAuswahl")){
		e.preventDefault();
		makeStandard();
		alert("New temporary standard registration");
	}
});

//------------------------------------


function addRegistration(reg){
	var regAusw = document.getElementById("registerAuswahl");
	var aktuelleRegistration = regAusw.innerHTML;
	if (confirm("REPLACE registration list?\n\nOK       = REPLACE\nCancel = ADD") == true){
		regAusw.innerHTML = reg;
	}
	else {
		regAusw.innerHTML = aktuelleRegistration + reg;
	}
	reset();
}

function pasted() {
	setTimeout(function(){
		var inputElement = document.getElementById("pasteInput");
		addRegistration(inputElement.value);
	}, 100);
	setTimeout(function(){
		document.getElementById("pasteInput").value="";
		reset();
	}, 1000);
}

function regOptionsFunction(value){
	switch (value){
		case "reset": reset(); document.getElementById("registerAuswahl").selectedIndex = 0; break;
		case "add": add(); break;
		case "remove": remove(); break;
		case "delete": deleteRegistration(); break;
		case "change": change(); break;
		case "copyToClipboard": copyListToClipboard(); break;

		case "copyOptionToClipboard": copyOptionToClipboard(); break;
		case "copySymbolsToClipboard": copySymbolsToClipboard(); break;
		case "copySymbolsToClipboard2": copySymbolsToClipboard2(); break;
		case "screenshot": screenshot(); break;
		case "saveJs": saveJs(); break;
		case "replace": addRegistration(standard); break;
		case "openReg": openReg(); break;
		case "saveReg": saveReg(); break;
	}
	document.getElementById('regOptions').getElementsByTagName('option')[0].selected = 'selected'
}

// open a registration file
function openReg() {
	var files = document.getElementById("regfile").files;
	var ziel = document.getElementById("registerAuswahl");

	var reader = new FileReader();

	// Closure to capture the file information
	reader.onloadend = function(evt) {
		addRegistration(evt.target.result);
	}

	// Read the file as text
	reader.readAsText(files[0], "UTF-8");
	reset();
	event.target.value = null;
	document.getElementById("registerAuswahl").focus();
}


function saveReg(){
	var quelle = document.getElementById("registerAuswahl");
	var fileContent = quelle.innerHTML;
	fileContent=fileContent.replace(/option><option/g, "option>\n<option");
	var bb = new Blob([fileContent ], { type: 'text/plain' });
	var a = document.createElement('a');
	a.download = 'download.txt';
	a.href = window.URL.createObjectURL(bb);
	a.click();
}


function regPlus(){
	var s = document.getElementById("registerAuswahl");
	var i = s.selectedIndex;
	if (i < s.options.length - 1){
		s.selectedIndex = i + 1;
		regEin(s.value.split(','))
	}
	s.focus();
}

function regMinus(){
	var s = document.getElementById("registerAuswahl");
	var i = s.selectedIndex;
	if (i > 0){
		s.selectedIndex = i - 1;
		regEin(s.value.split(','))
	}
	s.focus();
}

function remove(){
	var s = document.getElementById("registerAuswahl");
	s.remove(s.selectedIndex);
}

function deleteRegistration() {
	if (confirm("DELETE registration list?") == false) {
		return;
	}
	reset();
	var s = document.getElementById("registerAuswahl");
	s.innerHTML = "";
	var infoElement = document.getElementById("info");
	infoElement.innerHTML = "";
}

function saveJs(){
	var selectInhalt = document.getElementById("registerAuswahl").innerHTML;
//alert(selectInhalt);
	selectInhalt=selectInhalt.replace(/<\/option>/g, "</option>\\\n");
	selectInhalt=selectInhalt.replace(/\n\n/g, "\n");
//	selectInhalt=selectInhalt.replace(/</g, "&lt;");
//	selectInhalt=selectInhalt.replace(/>/g, "&gt;");

	var startInhalt = "standard='";
	var endInhalt ="';";

	var inhalt = startInhalt + selectInhalt + endInhalt;
//	alert(inhalt);

	var bb = new Blob([inhalt], { type: 'text/plain' });
	var a = document.createElement('a');
	a.download = 'standard.js';
	a.href = window.URL.createObjectURL(bb);
	a.click();
}

function makeStandard() {
	standard = document.getElementById("registerAuswahl").innerHTML;
}

function copyListToClipboard() {
	var textToCopy = document.getElementsByTagName("select")[0].innerHTML;
	//insert newlines
	textToCopy=textToCopy.replace(/option><option/g, "option>\n<option");
	textToCopy=textToCopy.replace(/option> <option/g, "option>\n<option");
	copyToClipboard(textToCopy);
}

function copyOptionToClipboard() {
	var el = document.getElementById("registerAuswahl")
	const collection = el.children;
	var textToCopy = "<option value='" + collection[el.selectedIndex].value + "'>" + collection[el.selectedIndex].innerHTML + "</option>\n";
	copyToClipboard(textToCopy);
}


function copySymbolsToClipboard() {
	var e = document.getElementById("registerAuswahl");
	var value = e.value;
	var text = e.options[e.selectedIndex].text;
	var regEingeschaltet = text + "\n";

	var info = document.getElementById("info").innerHTML;
	if (info){
		var regEingeschaltet = regEingeschaltet + info + "\n";
	}

	var regname = document.getElementsByClassName("regname");
	var regform = document.getElementsByClassName("regform");
	for (var i=0; i < regname.length; i++){
		if (registergruppe[i]){
			regEingeschaltet = regEingeschaltet + registergruppe[i];
		}
		if (eingeschaltet[i]== true){
				if (regform[i]=="[object SVGCircleElement]"){
					regEingeschaltet = regEingeschaltet + "⚫";
				}
				else{
					regEingeschaltet = regEingeschaltet + "■ ";
				}
		}
		else{
				if (regform[i]=="[object SVGCircleElement]"){
					regEingeschaltet = regEingeschaltet + "⚪";
				}
				else{
					regEingeschaltet = regEingeschaltet + "☐ ";
				}
		}
	}
	regEingeschaltet = regEingeschaltet + "\n\n";
	var ergebnis=regEingeschaltet  //.slice(0,regEingeschaltet.length - 1);
	copyToClipboard(ergebnis);
//	alert(ergebnis);
}

function copySymbolsToClipboard2() {
	var e = document.getElementById("registerAuswahl");
	var value = e.value;
	var text = e.options[e.selectedIndex].text;
	var regEingeschaltet = text + "\n";

	var info = document.getElementById("info").innerHTML;
	if (info){
		var regEingeschaltet = regEingeschaltet + info + "\n";
	}
	var regname = document.getElementsByClassName("regname");
	var regform = document.getElementsByClassName("regform");
	for (var i=0; i < printPos.length; i++){
		var n = printPos[i];
		if (!parseInt(n)){
			regEingeschaltet = regEingeschaltet + n;
		}
		else{
			if (eingeschaltet[n - 1]== true){
				if (regform[n-1]=="[object SVGCircleElement]"){
					regEingeschaltet = regEingeschaltet + "⚫";
				}
				else{
					regEingeschaltet = regEingeschaltet + "■ ";
				}
			}
			else{
				if (regform[n-1]=="[object SVGCircleElement]"){
					regEingeschaltet = regEingeschaltet + "⚪";
				}
				else{
					regEingeschaltet = regEingeschaltet + "☐ ";
				}
			}
		}
	}
	regEingeschaltet = regEingeschaltet + "\n\n";
	var ergebnis=regEingeschaltet  //.slice(0,regEingeschaltet.length - 1);
//	alert(ergebnis);
	copyToClipboard(ergebnis);
}

function screenshot(){
	svgWidth = exportGrafikBreite;

	//Auslesen von Registrationsname und Info-Feld
	var e = document.getElementById("registerAuswahl");
	var value = e.value;
	var text = e.options[e.selectedIndex].text;
	var regEingeschaltet = text + "\n";
	var info = document.getElementById("info").innerHTML;
	if (info==""){
		var titel = text + "\n\n";
	}
	else{
		var titel = text + "\n" + info + "\n\n";
	}
//	copyToClipboard(titel);
//	alert("TEXT:\n\n" + titel + "\n\nkopiert!")

	//Abfrage der Grafikbreite
	var svgWidth = prompt("Breite der Grafik:",svgWidth);
	if (svgWidth) {
		exportGrafikBreite = svgWidth;
	}
	else {
		svgWidth = "100";
	}
//	var svgCopy = "<svg width='" + svgWidth + "vH' viewBox='0 0 " + svgWidth + " " + svgWidth/2 + "'>" + document.getElementById("orgelGrafik").outerHTML + "</svg>";

	//Feststellen des Seitenverhältnisses der SVG-Grafik
	var vB = document.getElementById("orgelGrafik").getAttribute("viewBox").split(" ");
	var seitenverhaeltnis = vB[2]/vB[3]
	svgHeight = parseInt(svgWidth / seitenverhaeltnis);

	//Titel, Info und Grafik + umschließendes DIV in neues Fenster einsetzen
	var div1Begin = "<div class='wrapperAll' style='margin:0 auto; break-inside: avoid;'>";
	var div2Begin = "<div class='wrapperSvg' style='width:" + svgWidth + "vW; height:" + svgHeight + "vW; margin:0 auto;'>";
	var divEnd = "</div>";
	var svgCopy = document.getElementById("orgelGrafik").outerHTML;
	svgCopy = svgCopy.replace("viewBox=", "style='height:100%' viewbox="); 
//console.log(svgCopy);
	var svgWindow = window.open("","newWindow","width=600,height=400");
	svgWindow.document.write(div1Begin);
	svgWindow.document.write("<h1 style='text-align:center; font-family: sans-serif; font-size:1em; margin:0; margin-top:1em'>" + text + "</h1><p style='text-align:center; font-size=0.8em; margin:0;'>" + info + "</p>");
	svgWindow.document.write(div2Begin);
	svgWindow.document.write(svgCopy);
	svgWindow.document.write(divEnd);
	svgWindow.document.write(divEnd);
	// https://stackoverflow.com/questions/64570890/javascript-open-new-window-and-copy-over-css-references-from-the-current-window
	document.head.querySelectorAll('link, style').forEach(htmlElement => {
		svgWindow.document.head.appendChild(htmlElement.cloneNode(true));
		svgWindow.title=svgWindow.name;
	});
}